
/*
 * Esercizio 3 (lezione del 16/03/10)
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXLEN 1000

/*
 * Funzione char **leggi(int *N) (vedi esercizio 2 del 16/03/10):
 * Legge una sequenza di stringhe la cui lunghezza è specificata nella prima riga dell'input. Restituisce
 * un array di puntatori alle stringhe e scrive la lunghezza della sequenza nell'intero passato per riferimento
 */


char **leggi(int *N)
{
    int i;
    char **stringhe;

    scanf("%d", N); /* Numero di stringhe */

    stringhe = (char **)malloc(sizeof (char *) * (*N));
    if (stringhe == NULL) return NULL;

    for ( i = 0; i < *N; i++ ) 
    {
      stringhe[i] = (char *)malloc(sizeof(char)*(MAXLEN+1)); 
      scanf("%s", stringhe[i]);
    }

    return stringhe;
}

/* Funzione int BinarySearch(char ** A, int n, char *s):
 *  Cerca una stringa all'interno di un array di stringhe mediante ricerca binaria. I parametri in input sono
 *   A: array di stringhe, n: la lunghezza di A, s: stringa da cercare  
 */

int BinarySearch(char ** A, int n, char *s){

int left, right, mid;
int cmp;
left = 0;
right = n-1;

 while (left <= right){

   mid = (left + right)/2;
   cmp = strcmp(s,A[mid]);

   if (cmp == 0) return mid;
   else if (cmp > 0) left= mid+1;
   else right= mid-1; 
      
 }

return -1;
}

/* 
 * Funzione ausiliaria che restituisce un intero letto in input 
 */

int siContinua(){
 
 int e=0;
 scanf("%d",&e);
 return e; 

}

int main(){

int numStringhe, numQuery;
char ** A= leggi(&numStringhe);
char ** query;
char ** tmp;	      		      
int i;
int capacita = 1;

if (A == NULL) return 1;

  query = (char **) malloc( sizeof(char*)* capacita );
  if( query == NULL ) return 1;
  
  numQuery = 0;

  // raccoglie le query in un array costruito mediante doubling
 
  while( siContinua() ) {  // termina il ciclo di input della query quando riceve uno 0
    
    query[numQuery] = (char*)malloc(sizeof(char)*(MAXLEN+1));
	if (query[numQuery] == NULL) return 0;

    scanf("%s",query[numQuery]);
    numQuery++;                       

    if (numQuery == capacita) {     
	  capacita *= 2;               
	  tmp = (char **) malloc( sizeof(char*) * capacita );
	  if( tmp == NULL ) return 1;	
	    
	  for ( i = 0; i < numQuery; i++ ) 
	      tmp[i] = query[i];

	  free(query);                     
	  query = tmp;                   
      }
  
  }  


for (i=0; i< numQuery; i++)
 printf("%d\n",BinarySearch(A,numStringhe,query[i]));

return 0;
}







